<!DOCTYPE html>
<html lang="es">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Ejercicio_27</title>
</head>
<body>
    <h1>Ejercicio 27</h1>
    <script>
    /*27) Programa una clase llamada Pelicula.

La clase recibirá un objeto al momento de instanciarse con los siguentes datos: 
id de la película en IMDB, titulo, director, año de estreno, país o países de origen, 
géneros y calificación en IMBD.
  - Todos los datos del objeto son obligatorios.
  - Valida que el id IMDB tenga 9 caracteres, los primeros 2 sean letras y los 
     7 restantes números.
  - Valida que el título no rebase los 100 caracteres.
  - Valida que el director no rebase los 50 caracteres.
  - Valida que el año de estreno sea un número entero de 4 dígitos.
  - Valida que el país o paises sea introducidos en forma de arreglo.
  - Valida que los géneros sean introducidos en forma de arreglo.
  - Valida que los géneros introducidos esten dentro de los géneros 
     aceptados*.
  - Crea un método estático que devuelva los géneros aceptados*.
  - Valida que la calificación sea un número entre 0 y 10 pudiendo ser 
    decimal de una posición.
  - Crea un método que devuelva toda la ficha técnica de la película.
  - Apartir de un arreglo con la información de 3 películas genera 3 
    instancias de la clase de forma automatizada e imprime la ficha técnica 
    de cada película.
*/

    class Pelicula {

        constructor({id, titulo, director, estreno, pais, generos, calificacion}) {
            this.id = id;
            this.titulo = titulo;
            this.director = director;
            this.estreno = estreno;
            this.pais = pais;
            this.generos = generos;
            this.calificacion = calificacion;

            this.validarIMDB(id);
            this.validarTitulo(titulo);
            this.validarDirector(director);
            this.validarEstreno(estreno);
            this.validarPais(pais);
            this.validarGeneros(generos);
            this.validarCalificacion(calificacion);
        }

        static get listaGeneros() {
            return ["Action","Adult","Aventure","Animation","Biography","Comedy","Crime","Documentary",
                    "Drama","Family","Fantasy","Film Noir","Game Show","History","Horror","Musical",
                    "Music","Mystery","News","Reality - TV","Romance","Sci-Fi","Short","Sport",
                    "Talk-Show","Thriller","War","Western"]
        }

        static generosAceptados() {
            return console.info(`Los Generos aceptados son: ${Pelicula.listaGeneros.join(", ")}`);
        }

        //Validaciones de Cadenas, nuemeros, String, longitud
        validarCadena(propiedad, valor) {
            if (!valor) return console.warn(`${propiedad} "${valor}" esta vacìo`);
            if (typeof valor !== "string")
            return console.error(`${propiedad} "${valor}", ingresado No es una cadena de Texto`);
            return true;
        }

        validarLongCadena(propiedad, valor, longitud) {
            if(valor.length > longitud) 
            return console.error(`${propiedad} "${valor}", excede el # de caracteres que son ${longitud} caracteres`);
            return true;
        }

        validarNumero(propiedad, valor) {
            if(!valor) return console.warn(`${propiedad} "${valor}", esta vacìo`);
            if (typeof valor !== "number") 
            return console.error(`${propiedad} "${valor}", ingresado No es un Numero`);
        }

        validarArreglo(propiedad, valor) {
            if(!valor) return console.warn(`${propiedad} "${valor}", esta vacìo`);
            if(!(valor instanceof Array)) 
            return console.error(`${propiedad} "${valor}",ingresado No es un Arreglo`);
            if(valor.length === 0) 
            return console.error(`${propiedad} "${valor}", no tiene datos`);
            for(let cadena of valor) {
                if( typeof cadena !== "string") 
                return console.error(`El Valor ingresado: "${cadena}", no es una cadena de Texto`);
            }
            return true;
        }

        //Validaciones de la Pelicula
        validarIMDB(id) {
            if (this.validarCadena("IMDB id", id)) {
                if(!(/^([a-z]){2}([0-9]){7}$/.test(id)))
                    return console.error(`El id IMDB de: ${id}, no es valido, debe tener 9 caracters, 2 letras minusculas y 7 numeros asi el orden.`);
            }
        }

        validarTitulo(titulo) {
            if (this.validarCadena("Titulo", titulo)) {
                this.validarLongCadena("Titulo", titulo, 100);
            }
        } 

        validarDirector(director) {
            if (this.validarCadena("Director", director)) {
                this.validarLongCadena("Director", director, 50);
            }
        }

        validarEstreno(estreno) {
            if (this.validarNumero("Año de Estreno", estreno)) {
                if(!(/^([0-9]){4}$/.test(estreno)))
                    return console.error(`El Año que ingreso: "${estreno}" No es valido, deben ser 4 digitos.`);
            }
        }
        
        validarPais(pais) {
            this.validarArreglo("Pais", pais)
        }

        validarGeneros(generos) {
            if(this.validarArreglo("Generos", generos)) {
                for(let genero of generos) {
                    if(!Pelicula.listaGeneros.includes(genero)) {
                        console.error(`Gènero(s) igresados: "${generos.join(", ")}" no son aceptados`);
                        Pelicula.generosAceptados();
                    }
                }
            }
        }

        validarCalificacion(calificacion) {
            if (this.validarNumero("Calificaciòn", calificacion)) {
                return (calificacion < 0 || calificacion > 10)
                    ? console.error(`La calificaciòn debe ser de un rango de 0 a 10`)
                    : this.calificacion = calificacion.toFixed(1);
            }
        }

        fichaTecnica() {
            console.log(`Ficha Tècnica:\nTitulo: "${this.titulo}"\nDirector: "${this.director}"\nAño: "${this.estreno}"\nPais: "${this.pais.join(", ")}"\nGenero: "${this.generos.join(", ")}"\nCalicación: "${this.calificacion}"\nIMDB: "${this.id}"\n`)
        }


    }


    /*Pelicula.generosAceptados();
    const peli = new Pelicula({
        id: "tt1234567",
        titulo: "Chuek",
        director: "Negas",
        estreno: 2020,
        pais: ["Mèxico","Francia"],
        generos: ["Family", "Comedy"],
        calificacion: 9.9
    })

    peli.fichaTecnica();*/

    const misPelis = [
        {
            id: "tt1087260",
            titulo: "Spider-Man: No Way Home",
            director: "Jon Watts",
            estreno: 2021,
            pais: ["Estados Unidos"],
            generos: ["Action","Aventure","Fantasy","Sci-Fi"],
            calificacion: 8.7,
        },

        {
            id: "tt1690470",
            titulo: "Pokémon: Zoroark, el maestro de ilusiones",
            director: "Kunihiko Yuyama",
            estreno: 2010,
            pais: ["Japón"],
            generos: ["Animation","Action","Family","Fantasy"],
            calificacion: 6.1,
        },

        {
            id: "tt0914798",
            titulo: "El niño con el pijama de rayas",
            director: "Mark Herman",
            estreno: 2008,
            pais: ["Reino Unido","Estados Unidos"],
            generos: ["Drama","History","War"],
            calificacion: 7.8,
        }

    ]

    misPelis.forEach(el => new Pelicula(el).fichaTecnica());

    </script>
    
</body>
</html>